USE WORK.STD_LOGIC.ALL;
USE work.ALL;
entity adder2 is
    port (a1,a2,b1,b2, c_in: in t_wlogic; s1,s2, c_out: inout t_wlogic);
end adder2;
architecture adder2_xfr of adder2 is
    component adder1 
          port( a,b, c_in: in t_wlogic; s,c_out: inout t_wlogic); 
    end component;
    signal tc_out: t_wlogic;
begin
    ia1: adder1 port map( a1, b1, c_in, s1, tc_out );
    ia2: adder1 port map( a2, b2, tc_out, s2, c_out );
end adder2_xfr;

USE WORK.STD_LOGIC.ALL;
USE work.ALL;
entity adder2_top is
end adder2_top;

architecture adder2_top_xfr of adder2_top is
    component adder2 
          port( a1, a2, b1, b2, c_in: in t_wlogic; 
                s1, s2, c_out: inout t_wlogic); 
    end component;
    signal ta1, ta2, tb1, tb2, tc_in, ts1, ts2, tc_out: t_wlogic;
begin
    a1: adder2 port map( ta1, ta2, tb1, tb2, tc_in, ts1, ts2, tc_out );
    ta1 <= f0 after 1 ns when ta1 = f1 else f1 after 1 ns;
    ta2 <= f0 after 2 ns when ta2 = f1 else f1 after 2 ns;
    tb1 <= f0 after 4 ns when tb1 = f1 else f1 after 4 ns;
    tb2 <= f0 after 8 ns when tb2 = f1 else f1 after 8 ns;
    tc_in <= f0;
end adder2_top_xfr;

