USE WORK.STD_LOGIC.ALL;
USE work.ALL;
entity adder4 is
    port (a1,a2,a3,a4,b1,b2,b3,b4, c_in: in t_wlogic; 
          s1,s2,s3,s4,c_out: inout t_wlogic);
end adder4;
architecture adder4_xfr of adder4 is
    component adder1 
          port( a,b, c_in: in t_wlogic; s,c_out: inout t_wlogic); 
    end component;
    signal tc_out1, tc_out2, tc_out3: t_wlogic;
begin
    ia1: adder1 port map( a1, b1, c_in,    s1, tc_out1 );
    ia2: adder1 port map( a2, b2, tc_out1, s2, tc_out2 );
    ia3: adder1 port map( a3, b3, tc_out2, s3, tc_out3 );
    ia4: adder1 port map( a4, b4, tc_out3, s4, c_out );
end adder4_xfr;

USE WORK.STD_LOGIC.ALL;
USE work.ALL;
entity adder4_top is
end adder4_top;
architecture adder4_top_xfr of adder4_top is
    component adder4 
          port( a1, a2, a3, a4, b1, b2, b3, b4, c_in: in t_wlogic; 
                s1, s2, s3, s4, c_out: inout t_wlogic); 
    end component;
    signal ta1, ta2, ta3, ta4, tb1, tb2, tb3, tb4, tc_in, 
           ts1, ts2, ts3, ts4, tc_out: t_wlogic;
begin
    ia: adder4 port map( ta1, ta2, ta3, ta4, tb1, tb2, tb3, tb4, tc_in,
                         ts1, ts2, ts3, ts4, tc_out );
    ta1 <= f0 after 1 ns when ta1 = f1 else f1 after 1 ns;
    ta2 <= f0 after 2 ns when ta2 = f1 else f1 after 2 ns;
    tb1 <= f0 after 4 ns when tb1 = f1 else f1 after 4 ns;
    tb2 <= f0 after 8 ns when tb2 = f1 else f1 after 8 ns;

    ta3 <= f0 after 1 ns when ta3 = f1 else f1 after 1 ns;
    ta4 <= f0 after 2 ns when ta4 = f1 else f1 after 2 ns;
    tb3 <= f0 after 4 ns when tb3 = f1 else f1 after 4 ns;
    tb4 <= f0 after 8 ns when tb4 = f1 else f1 after 8 ns;
    tc_in <= f0;
end adder4_top_xfr;

