USE WORK.STD_LOGIC.ALL;
USE work.ALL;
entity adder6 is
    port (a1,a2,a3,a4,a5,a6,b1,b2,b3,b4,b5,b6, c_in: in t_wlogic; 
          s1,s2,s3,s4,s5,s6,c_out: inout t_wlogic);
end adder6;
architecture adder6_xfr of adder6 is
    component adder1 
          port( a,b, c_in: in t_wlogic; s,c_out: inout t_wlogic); 
    end component;
    signal tc_out1, tc_out2, tc_out3, tc_out4, tc_out5: t_wlogic;
begin
    ia1: adder1 port map( a1, b1, c_in,    s1, tc_out1 );
    ia2: adder1 port map( a2, b2, tc_out1, s2, tc_out2 );
    ia3: adder1 port map( a3, b3, tc_out2, s3, tc_out3 );
    ia4: adder1 port map( a4, b4, tc_out3, s4, tc_out4 );
    ia5: adder1 port map( a5, b5, tc_out4, s3, tc_out5 );
    ia6: adder1 port map( a6, b6, tc_out5, s4, c_out );
end adder6_xfr;

USE WORK.STD_LOGIC.ALL;
USE work.ALL;
entity adder6_top is
end adder6_top;

architecture adder6_top_xfr of adder6_top is
    component adder6 
          port( a1, a2, a3, a4, a5, a6, 
                b1, b2, b3, b4, b5, b6, c_in: in t_wlogic; 
                s1, s2, s3, s4, s5, s6, c_out: inout t_wlogic); 
    end component;
    signal ta1, ta2, ta3, ta4, ta5, ta6,
           tb1, tb2, tb3, tb4, tb5, tb6, tc_in, 
           ts1, ts2, ts3, ts4, ts5, ts6, tc_out: t_wlogic;
begin
    ia: adder6 port map( ta1, ta2, ta3, ta4, ta5, ta6,
                         tb1, tb2, tb3, tb4, tb5, tb6, tc_in,
                         ts1, ts2, ts3, ts4, ts5, ts6, tc_out );
    ta1 <= f0 after 1 ns when ta1 = f1 else f1 after 1 ns;
    ta2 <= f0 after 2 ns when ta2 = f1 else f1 after 2 ns;
    tb1 <= f0 after 4 ns when tb1 = f1 else f1 after 4 ns;
    tb2 <= f0 after 8 ns when tb2 = f1 else f1 after 8 ns;

    ta3 <= f0 after 1 ns when ta3 = f1 else f1 after 1 ns;
    ta4 <= f0 after 2 ns when ta4 = f1 else f1 after 2 ns;
    tb3 <= f0 after 4 ns when tb3 = f1 else f1 after 4 ns;
    tb4 <= f0 after 8 ns when tb4 = f1 else f1 after 8 ns;

    ta5 <= f0 after 1 ns when ta5 = f1 else f1 after 1 ns;
    ta6 <= f0 after 2 ns when ta6 = f1 else f1 after 2 ns;
    tb5 <= f0 after 4 ns when tb5 = f1 else f1 after 4 ns;
    tb6 <= f0 after 8 ns when tb6 = f1 else f1 after 8 ns;
    tc_in <= f0;
end adder6_top_xfr;
