USE WORK.STD_LOGIC.ALL;
USE work.ALL;
entity nand2 is
    port (a,b: in t_wlogic; z: inout t_wlogic);
end nand2;

architecture nand2_xfr of nand2 is
    component nfet 
          generic (gdelay : time := 3 ps;
                   MaxStrength: t_strength := 'R');
          port( g: in t_wlogic; src,drn: inout t_wlogic); 
    end component;
    component pfet 
          generic (gdelay : time := 3 ps;
                   MaxStrength: t_strength := 'R');
          port( g: in t_wlogic; src,drn: inout t_wlogic); 
    end component;
    signal t2 : t_wlogic;
    signal vdd : t_wlogic := F1;
    signal gnd : t_wlogic := F0;
begin
    i0: pfet port map( a, z, vdd );
    i1: pfet port map( b, z, vdd );
    i2: nfet port map( b, z, t2 );
    i3: nfet port map( a, t2, gnd );
    vdd <= F1;
    gnd <= F0;
end nand2_xfr;

USE WORK.STD_LOGIC.ALL;
USE WORK.ALL;
entity nand2_top is
end nand2_top;

architecture nand2_top_xfr of nand2_top is
    component nand2 
       port (a,b: in t_wlogic; z: inout t_wlogic);
    end component;
    signal ta,tb : t_wlogic := f0;
    signal tz : t_wlogic;
begin
    i1: nand2 port map( ta, tb, tz );
    ta <= f0 after 1 ns when ta = f1 else f1 after 1 ns;
    tb <= f0 after 2 ns when tb = f1 else f1 after 2 ns;
end nand2_top_xfr;








