USE work.summing_bus_res_function.all;
PACKAGE analog_data_structure IS
--
-- analog time step
--
   CONSTANT analog_time_delta	  : time := 100 ps;
   CONSTANT analog_time_delta_real: real := 0.1; --ns
--
-- analog signal
--
    TYPE signal_mode IS (v, i);
    TYPE analog_signal IS RECORD
      val:   brf_real;
      kind:  signal_mode;
    END RECORD;
--
-- analog reference
--
    TYPE analog_reference_aref IS RECORD
      val:   real;
    END RECORD;
--
-- analog component
--
  TYPE component_element IS (res, cap, ind);
  TYPE analog_component IS RECORD
    val:   real;
    kind:  component_element;
  END RECORD;
--
-- analog threshold levels
--
  TYPE analog_v_level IS RECORD
    val:   real;
  END RECORD;
--
-- analog gain
--
  TYPE analog_vv_gain IS RECORD
    val:   real;
  END RECORD;
--
--general parms
--
  TYPE frequency IS RECORD
    val:   real;
  END RECORD;
  TYPE amplitude IS RECORD
    val:   real;
  END RECORD;
--
END analog_data_structure;
