USE work.tline_data_structure.all;
USE work.tline_active_behaviors.all;

-- interface
ENTITY general_drv IS
    GENERIC ( hi      : real  := 5.0  ; -- volts
	      low     : real  := 0.0  ; -- volts
	      d_kind  : sig_mode := v  ;
	      r_out   : real  := 0.080; -- kohms
	      t_delay : time  := 1 ns);
    PORT    ( drv_in  : IN     bit;
	      drv_out : INOUT  tline_node := (volt=>0.0, g0=>g_min,
					     volt_fe=>0.0, cur_fe=>0.0));

BEGIN

    ASSERT( r_out > 0.0 )
	  REPORT "ERROR: tline_drv Rout must be > 0.0"
	  SEVERITY failure;

END general_drv;

-- body
ARCHITECTURE general_drv_behavior OF general_drv IS
    BEGIN
     drv_out.g0 <= g_max; -- short it so tline drives 0.0v

P1:  PROCESS(drv_out.volt_fe, drv_in)
     BEGIN
	   drv_out.volt <= drive_general(drv_in, r_out, drv_out,
					 low, hi, d_kind);
     END PROCESS p1;
--
END general_drv_behavior;
