USE work.analog_data_structure.all;
USE work.scientific.all;
-- interface
ENTITY func_gen IS
    GENERIC ( amp     : amplitude      := ( val => 1.0 ) ;
	      offset  : analog_v_level := ( val => 0.0)  ;
	      freq    : frequency      := ( val => 0.001) );
    PORT    ( v_sine  : OUT  analog_signal := (val => 0.0, kind => v);
	      v_sine2 : OUT  analog_signal := (val => 0.0, kind => v));
END func_gen;

-- body
ARCHITECTURE func_gen_behavior OF func_gen IS
  BEGIN

  P1:PROCESS
       VARIABLE temp_v, simtime  : real := 0.0;
       CONSTANT period : real := 1.0/freq.val;
     BEGIN
       temp_v := amp.val * sin(6.2832*freq.val*simtime);

       v_sine.val <= temp_v + offset.val;
       v_sine2.val <= -temp_v + offset.val;

       WAIT FOR analog_time_delta;
       IF simtime <= period and
	  simtime > (period - analog_time_delta_real) THEN
	 simtime := analog_time_delta_real;
       ELSE
	 simtime := simtime + analog_time_delta_real;
       END IF;

     END PROCESS;

END func_gen_behavior;

