USE work.analog_data_structure.all;

-- interface
ENTITY receiver1 IS
    GENERIC ( v_sw_hi  : real	:=  1.0  ; -- volts
	      v_sw_low : real	:=  1.0  ; -- volts
	      t_delay  : time	:=  1 ns	);
    PORT    ( rec_in   : IN   analog_signal := (val=> 0.0, kind=> v);
	      rec_out: BUFFER bit	);
END receiver1;

-- body
ARCHITECTURE receiver1_behavior OF receiver1 IS
    BEGIN
     rec_out <= '1' AFTER t_delay WHEN (rec_in.val > v_sw_hi ) ELSE
		'0' AFTER t_delay WHEN (rec_in.val < v_sw_low) ELSE
	    rec_out AFTER t_delay;

--
END receiver1_behavior;
