USE work.analog_data_structure.all;
-- interface
ENTITY env  IS
    GENERIC ( imag_sink   : real := 0.5  ;
	      imag_source : real := 0.35 ;
	      db_percent  : real := 0.2  ;
	      t_delay	  : time := 1 ns  );
    PORT    ( vin      : IN	analog_signal;
	      iout     : BUFFER analog_signal := (val => 0.0, kind => i);
	      vref     : IN	analog_signal;
	      vcenter  : IN	analog_signal );
END env;

-- body
ARCHITECTURE env_behavior OF env IS
    BEGIN
    iout.kind <= i;
    iout.val  <=    -imag_sink	 AFTER t_delay WHEN
   (   (vref.val)     < (vin.val - vcenter.val) OR
       (vref.val)     < (vcenter.val - vin.val)     )	ELSE
		  imag_source AFTER t_delay WHEN
   (   (vref.val)*(db_percent) < (vin.val - vcenter.val) OR
       (vref.val)*(db_percent) < (vcenter.val - vin.val)     )	 ELSE
		     0.0   AFTER t_delay;
--
END env_behavior;
