USE work.analog_data_structure.all;
USE work.analog_passive_behaviors.all;
-- interface
ENTITY cap_filter IS
    GENERIC ( c : analog_component := (val => 0.0, kind => cap ) );
    PORT    ( iin     : IN     analog_signal;
	      vout    : BUFFER analog_signal := (val => 0.0, kind => v));

BEGIN
    ASSERT( c.val > 0.0 )
       REPORT "ERROR: C must be > 0"
       SEVERITY failure;

END cap_filter;

-- body
ARCHITECTURE cap_filter_behavior OF cap_filter IS
    SIGNAL pvout : analog_signal :=
	   ( val => 2.7, kind => v );

    BEGIN
      vout  <= capf(c, iin, pvout );
      pvout <= vout AFTER analog_time_delta;

END cap_filter_behavior;
