-- interface
ENTITY phase_freq IS
    PORT    (	data_in: IN	bit;
		vco_in : IN	bit;
		inc    : BUFFER bit;
		dec    : BUFFER bit);
END phase_freq;

-- body
ARCHITECTURE phase_freq_structure OF phase_freq IS
       SIGNAL data_bar, vco_bar, reset	: bit := '0';

    BEGIN
      reset <= data_bar NOR vco_bar;

BA:   BLOCK ( (data_in = '1' AND (NOT data_in'STABLE) ) OR
	      (reset   = '1' AND (NOT reset'STABLE) )  )
      BEGIN
	 inc <= GUARDED  '1' AFTER 1 ns WHEN (reset = '0') ELSE
			 '0' AFTER 1 ns;
	 data_bar <= NOT inc;

      END BLOCK BA;

BB:   BLOCK ( (vco_in = '1' AND (NOT vco_in'STABLE) ) OR
	      (reset  = '1' AND (NOT reset'STABLE) )  )
      BEGIN
	 dec <= GUARDED  '1' AFTER 1 ns WHEN (reset  = '0') ELSE
			 '0' AFTER 1 ns;
	 vco_bar <= NOT dec;

      END BLOCK BB;

END phase_freq_structure;
