USE work.summing_bus_res_function.all;
PACKAGE tline_data_structure IS
--
-- transmission line max and min load limits
--
   CONSTANT g_min : real :=	 0.0001; -- 0.1  micro mho
   CONSTANT g_max : real :=  10000.0   ; -- 10.0 mhos

   CONSTANT r_min : real :=	 0.0001; -- 0.1  ohms
   CONSTANT r_max : real :=  10000.0   ; -- 10.0 mega ohms
--
-- signals
--
    TYPE sig_mode IS (v,i);
--
-- transmission line node
--
    TYPE tline_node IS RECORD
      volt     :  brf_real;
      g0       :  brf_real;
      volt_fe  :  brf_real;
      cur_fe   :  brf_real;
    END RECORD;
    --
--
-- transmission line traveling signal
--
    TYPE tline_traveler IS RECORD
      volt:  brf_real;
    END RECORD;
    --
--
-- transmission line branch
--
    TYPE tline_branch IS RECORD
      cur :  brf_real;
    END RECORD;
    --
--
END tline_data_structure;
