package sympack is
-- types used for simulation
type db_time is (min, typ, max);
type tp_values is array (db_time'LOW to db_time'HIGH) of time;
type tec_type is (ttl,cmos,ecl,pmos,nmos,jam_latch,
                  bus_keeper,open_collector,open_drain);
type logic8 is ('U','X','0','1','Z','W','L','H');
subtype logic7 is logic8 range 'X' to 'H';
subtype logic4 is logic8 range 'X' to 'Z';
type tv18 is array (positive range <>) of tp_values;
type part_names is array(natural range 1 to 24) of character;
type pm18 is array (positive range <>) of part_names; -- part names
type sense724 is array (logic7'low to logic7'high) of logic4;
type vector427 is array (logic4'low to logic4'high) of logic7;
type table427 is array (tec_type'low to tec_type'high) of vector427;
type logict is array (natural range <>) of tp_values;
-- definition of global constants
constant Logic_Error_Handling:boolean;
constant Tpd_Handling: boolean;
constant Assert_Message_Level: severity_level;
constant tc: db_time;
constant rsense: sense724:= ('X','0','1','Z','X','0','1');
constant drive_tab: table427 :=
         (('X','0','1','Z'),  -- ttl
          ('X','0','1','Z'),  -- cmos
          ('X','L','1','Z'),  -- ecl
          ('X','Z','1','X'),  -- pmos
          ('X','0','H','Z'),  -- nmos
          ('W','L','H','X'),  -- jam latch
          ('W','Z','H','X'),  -- bus keeper
          ('X','0','Z','X'),  -- open collector
          ('X','Z','1','X')); -- open drain
--
function sense(s1:logic7) return logic4;
--
function ttl_drive(s1:logic4) return logic7;
--
end sympack;
package body sympack is
-- deferred constant definition
constant Logic_Error_Handling: boolean:=FALSE;
constant TPD_Handling: boolean:= FALSE;
constant Assert_Message_Level: severity_level:= WARNING;
constant tc: db_time:= typ;
--
function sense(s1:logic7) return logic4 is
begin
  return rsense(s1);
end sense;
--
function ttl_drive(s1:logic4) return logic7 is
begin
  return drive_tab(ttl)(s1);
end ttl_drive;
--
end sympack;
