package sympack is
type db_time is (min, typ, max);
type tp_values is array (db_time'LOW to db_time'HIGH) of time;
type out_type is (ttl_cmos,ecl,pmos,nmos,jam_latch,
                  bus_keeper,open_collector,open_drain);
type logic8 is ('U','X','0','1','Z','W','L','H');
subtype logic7 is logic8 range 'X' to 'H';
subtype logic4 is logic8 range 'X' to 'Z';
type tv18 is array (positive range <>) of tp_values; -- prop delay triptic for parts
type part_names is array(natural range 1 to 24) of character;
type pm18 is array (positive range <>) of part_names; -- part names
type vector427 is array (logic4'low to logic4'high) of logic7;
type logic427 is array (out_type'low to out_type'high) of vector427; 
type logict is array (natural range <>) of tp_values; 
type sense724 is array (logic7'low to logic7'high) of logic4;
constant TPD_Handling: boolean;
constant Assert_Message_Level: severity_level;
constant tc: db_time;
constant values427: logic427 :=
         (('X','0','1','Z'),
          ('X','L','1','Z'),
          ('X','Z','1','X'),
          ('X','0','H','Z'),
          ('W','L','H','X'),
          ('W','Z','H','X'),
          ('X','0','Z','X'),
          ('X','0','Z','X'));
constant rsense: sense724:= ('X','0','1','Z','X','0','1');
--
function drive(s1:logic4) return logic7;
--
function sense(s1:logic7) return logic4;
--
end sympack;

package body sympack is
-- deferred constant definition
constant TPD_Handling: boolean:= TRUE;
constant Assert_Message_Level: severity_level:= WARNING;
constant tc: db_time:= typ;
--
function drive(s1:logic4) return logic7 is
-- insert one of the following choices as the
-- first index to values427 constant table:
-- ttl_cmos, ecl, pmos, nmos, jam_latch,
-- bus_keeper, open_collector, open_drain
begin
  return values427(ttl_cmos)(s1);
end drive;
--
function sense(s1:logic7) return logic4 is
begin
  return rsense(s1);
end sense;
--
end sympack;

