use work.sympack.all;
use work.utilpack.all;
entity STD86 is
-- (c)copyright Albatec - 1990
-- Quadruple 2-input exclusive-or gate
-- April 1990
-- Initial Release
     generic ( part_type: string:="DEFAULT";
               tplh_low: tp_values := (0 ns,0 ns,0 ns);
               tphl_low: tp_values := (0 ns,0 ns,0 ns);
               tplh_high: tp_values := (0 ns,0 ns,0 ns);
               tphl_high: tp_values := (0 ns,0 ns,0 ns));

     port (A1,B1,A2,B2,A3,B3,A4,B4: in logic7;
           Y4,Y3,Y2,Y1: out logic7);
constant part_types: pm18:=
         ("DEFAULT                 ",
          "SN5486                  ",
          "SN54L86                 ",
          "SN54LS86A               ",
          "SN54S86                 ",
          "SN7486                  ",
          "SN74LS86A               ",
          "SN74S86                 ");
constant spec_time: tv18:=
         ( tphl_low,tphl_low,tplh_high,tphl_high,       --DEFAULT
          (5.25 ns,15 ns,23 ns),(3.85 ns,11 ns,17 ns),   --SN5486
          (6.3 ns,18 ns,30 ns),(4.55 ns,13 ns,22 ns),
          (26.25 ns,75 ns,150 ns),(21 ns,60 ns,150 ns),  --SN54L86
          (17.5 ns,50 ns,90 ns),(12.25 ns,35 ns,60 ns),
          (4.2 ns,12 ns, 23 ns),(3.5 ns, 10 ns, 17 ns),  --SN54LS86A
          (7 ns, 20 ns, 30 ns),(4.6 ns, 13 ns, 22 ns),
          (2.45 ns,7 ns,10.5 ns),(1.75 ns,6.5 ns,10 ns), --SN54S86
          (2.45 ns,7 ns,10.5 ns),(1.75 ns,6.5 ns,10 ns),
          (5.25 ns,15 ns,23 ns),(3.85 ns,11 ns,17 ns),   --SN7486
          (6.3 ns,18 ns,30 ns),(4.55 ns,13 ns,22 ns),
          (4.2 ns,12 ns, 23 ns),(3.5 ns, 10 ns, 17 ns),  --SN74LS86A
          (7 ns, 20 ns, 30 ns),(4.6 ns, 13 ns, 22 ns),
          (2.45 ns,7 ns,10.5 ns),(1.75 ns,6.5 ns,10 ns), --SN74S86
          (2.45 ns,7 ns,10.5 ns),(1.75 ns,6.5 ns,10 ns));
constant cpt:part_names:=pad(part_type);
constant ctplh_low:tp_values:=spec_time(pick_tpd(cpt,part_types));
constant ctphl_low:tp_values:=spec_time(pick_tpd(cpt,part_types)+1);
constant ctplh_high:tp_values:=spec_time(pick_tpd(cpt,part_types)+2);
constant ctphl_high:tp_values:=spec_time(pick_tpd(cpt,part_types)+3);
end STD86;
--
architecture A_STD86 of STD86 is
  component EXOR2
    generic (tplh_low,tphl_low,tplh_high,tphl_high: tp_values);
    port (A,B: in logic7;
          Y: out logic7);
  end component;
  for all: exor2 use entity work.exor2(behavior)
      port map (A => sense (A), B => sense (B), drive (Y) => Y);
begin
  U1: EXOR2
        generic map (ctplh_low,ctphl_low,ctplh_high,ctphl_high)
        port map (A1, B1, Y1) ;
  U2: EXOR2
        generic map (ctplh_low,ctphl_low,ctplh_high,ctphl_high)
        port map (A2, B2, Y2) ;
  U3: EXOR2
        generic map (ctplh_low,ctphl_low,ctplh_high,ctphl_high)
        port map (A3, B3, Y3) ;
  U4: EXOR2
        generic map (ctplh_low,ctphl_low,ctplh_high,ctphl_high)
        port map (A4, B4, Y4) ;
end A_STD86;
