--
-- Figure 7.1.  Procedural Full-Adder Model
-- Taken from "Applications of VHDL to Circuit Design", page 199
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 

package gates is
  procedure xor2( signal a,b : in bit; signal z : out bit );
  procedure  or2( signal a,b : in bit; signal z : out bit );
  procedure and2( signal a,b : in bit; signal z : out bit );
end gates;

entity full_adder is
  port(
    a,b,cin : in bit;
    sum,cout : out bit );
end full_adder;

architecture subprogs of full_adder is
  use work.gates.all;
  signal s1, s2, s3 : bit;
begin
  p1: xor2( a,b,s1 );
  p2: xor2( s1,cin,sum );
  p3: and2( s1,cin,s2 );
  p4: and2( a,b,s3 );
  p5: or2 ( s2,s3,cout );
end subprogs; 
--



