--
-- Figure 7.4.  Correct Model for a 4-bit Register
-- Taken from "Applications of VHDL to Circuit Design", page 203
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 1) Made this example self-contained.
-- 

entity register_4 is
  port( 
    clock,reset : in  bit;
    data_in  : in  bit_vector( 0 to 3 );
    data_out : out bit_vector( 0 to 3 ) );
end register_4;

architecture WORKS of register_4 is
begin
  handle_both:
  process( clock, reset )
  begin
    -- do_reset
    if ((reset = '1') and (reset'event)) then
      data_out <= B"0000";

    -- do_clock
    elsif ((reset = '0') and (clock = '1') and (clock'event)) then
      data_out <= data_in;
    end if;
  end process handle_both;
end WORKS;
--


