--
-- Figure 7.6.  Single 'Out' Mode Port Driving Signal
-- Taken from "Applications of VHDL to Circuit Design", page 206
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 

package mvl_pack is
  type mvl is ( '0', '1', 'x', 'z' );
  type mvl_vector is array( natural range <> ) of mvl;
  function WIRE_X ( s : mvl_vector ) return mvl;
end mvl_pack;

package body mvl_pack is
  function WIRE_X ( s : mvl_vector ) return mvl is
    variable result : mvl := 'z';
  begin
    for I in s'range loop
      case s(i) is
      when '0' | '1'=> if (result /= 'z') then
                         assert (false) report "bus error";
                         return 'x';
                       else
                         result := s(i);
                       end if;
      when 'x'      => return 'x';
      when 'z'      => next;
      end case;
    end loop;
    return result;
  end;
end mvl_pack;

use work.mvl_pack.all;
entity test is
  port( flag : out WIRE_X mvl := '0' );
end test;

architecture oneport of test is
  component drive_comp
    port ( o : out mvl );
  end component;
begin
  c1: drive_comp port map( flag );
end oneport; 
--


