--
-- Figure 7.8.  Use Intermediate Signals instead of Variables
-- Taken from "Applications of VHDL to Circuit Design", page 209
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 1) Made the example self-contained.
-- 

entity counter is
  port( 
    clk,reset : in  bit;
    data  : out integer );
end counter;

architecture behavioral2 of counter is
  signal resetcount, incrcount, count : integer := 0;
begin
  process( reset )
  begin
    if (reset = '1') then
      resetcount <= 0;
    end if;
  end process;
  process( clk )
  begin
    if (clk = '1') and (reset = '0') then
      incrcount <= count + 1;
    end if;
  end process;

  count <= resetcount when (not resetcount'quiet) else
           incrcount  when (not incrcount'quiet) else
           count;

  data <= count;
end behavioral2;
--


