--
-- Figure 7.9.  Resolution Function for Resolving Registers
-- Taken from "Applications of VHDL to Circuit Design", page 210
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 1) Putting the function into a package, so it can be compiled.
-- 

package outer is
  type int_array is array( natural range <> ) of integer;
  function resolved( s : in int_array ) return integer;
end outer;

package body outer is
  function resolved( s : in int_array ) return integer is
  begin
    if (s'length > 1) then
      if (now = 0 ns) then
        return s(s'left);
      end if;
      assert false report "Bus contention on signal count.";
      return 0;
    end if;
    return s(s'left);
  end;
end outer;
--


