--
-- Figure 7.13.  Package Defining Resolution Function for type BIT
-- Taken from "Applications of VHDL to Circuit Design", page 215
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 

package resolve_bit is
  function bus_resolve( s : bit_vector ) return bit;
  subtype rbit is bus_resolve bit;
  type rbit_vector is array( natural range <> ) of rbit;
  subtype rbit4 is rbit_vector( 3 downto 0 );
end resolve_bit;

package body resolve_bit is
  function bus_resolve( s : bit_vector ) return bit is
  begin
    if (s'length = 0) then
      assert (false) report "zero sources driving bus";
      return '0';
    elsif (s'length /= 1) and (now /= 0 ns) then
      assert (false) report "multiple sources driving bus";
      return '0';
    else
      return s(s'left);
    end if;
  end bus_resolve;
end resolve_bit;
--


