--
-- Figure 7.15.  4-bit Register with Asynchronous Reset
-- Taken from "Applications of VHDL to Circuit Design", page 20
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 

entity register4 is
  port(
    clock,reset : in  bit;
    data_in     : in  bit_vector( 0 to 3 );
    data_out    : out bit_vector( 0 to 3 ) );
end register4;

architecture behavioral of register4 is
begin
  process( clock, reset )
  begin
    if ((reset = '1') and (reset'event)) then
      data_out <= B"0000";
    elsif ((reset = '0') and (clock = '1') and (not clock'stable)) then
      data_out <= data_in;
    end if;
  end process;
end behavioral;
--


