--
-- Figure 7.17.  Full Test Bench for Full Adder from Figure 7.1
-- Taken from "Applications of VHDL to Circuit Design", page 223
--
-- Ken Scott
-- January 29, 1991
--
-- Modifications:
-- 1) Added comment indicating the need to create the 'f7.18.stm' file.
-- 2) Added top level testbench for simulation purposes
-- 

entity tester is
  port (
    a,b,cin : out bit;
    sum,cout : in bit );
end tester;

use std.textio.all;
architecture use_textio of tester is
begin
  read_apply_check:
  process
    file stimulus : text is in "ex7_18.stm";  -- note:  need to create this!
    variable vector : line;
    variable value : bit;
    variable space : character;
    variable t : time;
  begin
    while (not endfile(stimulus)) loop
      readline( stimulus,vector );
      -- Format:
      -- ApplyTime, a,b,cin, WaitTime, expect_sum,expect_cout
      read( vector,t );      wait for (t - now);
      read( vector,space );
      read( vector,value );  a <= value;
      read( vector,value );  b <= value;
      read( vector,value );  cin <= value;
      read( vector,space );
      read( vector,t );      wait for t;
      read( vector,space );
      read( vector,value );  assert (sum = value);
      read( vector,value );  assert (cout = value);
    end loop;
    wait;
  end process;
end use_textio;
--

entity testbench is
end;

architecture sim of testbench is
  component tester port (a, b, cin: out bit; sum, cout: in bit); end component;
  component full_adder port (a,b,cin: in bit; sum,cout: out bit); end component;
  signal a, b, cin, sum, cout : bit;
begin
  c1: tester port map (a, b, cin, sum, cout);
  c2: full_adder port map (a, b, cin, sum, cout);
end;
